package com.io.yaohun.worldbosshurt.event;

import com.io.yaohun.worldbosshurt.data.BossData;
import com.io.yaohun.worldbosshurt.data.RewardData;
import org.bukkit.entity.Player;
import org.bukkit.event.Event;
import org.bukkit.event.HandlerList;

import java.util.LinkedHashMap;

public class WorldBossDamageEvent extends Event {

    private static HandlerList handlers = new HandlerList();
    private Player player;
    private double damage;
    private BossData bossData;

    @Override
    public HandlerList getHandlers() {
        return handlers;
    }
    public static HandlerList getHandlerList() {
        return handlers;
    }
    public WorldBossDamageEvent(Player player,BossData bossData,double damage) {
        this.player = player;
        this.bossData = bossData;
        this.damage = damage;
    }

    public Player getPlayer() {return player;}
    public String getBossKey(){return bossData.getBossKey();}
    public String getMobName() {
        return bossData.getBossName();
    }
    public BossData getBossData() {
        return bossData;
    }

    public double getDamage() {
        return damage * 1000;
    }
}
