package com.io.yaohun.worldbosshurt.event;

import com.io.yaohun.worldbosshurt.data.BossData;
import com.io.yaohun.worldbosshurt.data.RewardData;
import org.bukkit.event.Event;
import org.bukkit.event.HandlerList;

import java.util.LinkedHashMap;

public class WorldBossDeathEvent extends Event {

    private static HandlerList handlers = new HandlerList();
    private BossData bossData;
    private RewardData rewardData;
    private LinkedHashMap<String, Double> sortedMap;

    @Override
    public HandlerList getHandlers() {
        return handlers;
    }
    public static HandlerList getHandlerList() {
        return handlers;
    }
    public WorldBossDeathEvent(BossData bossData,RewardData rewardData,LinkedHashMap<String, Double> sortedMap) {
        this.bossData = bossData;
        this.rewardData = rewardData;
        this.sortedMap = sortedMap;
    }

    public String getBossKey(){
        return bossData.getBossKey();
    }

    public String getMobName() {
        return bossData.getBossName();
    }
    public BossData getBossData() {
        return bossData;
    }

    public RewardData getRewardData() {
        return rewardData;
    }
    public LinkedHashMap<String, Double> getSortedMap() {
        return sortedMap;
    }
}
