package com.io.yaohun.worldbosshurt.listener;

import com.io.yaohun.worldbosshurt.Main;
import com.io.yaohun.worldbosshurt.data.BossData;
import com.io.yaohun.worldbosshurt.mangage.BossManage;
import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.Bukkit;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Player;
import org.bukkit.entity.Projectile;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityDamageByEntityEvent;

import java.util.HashMap;
import java.util.UUID;

public class BossArmor implements Listener {

    private HashMap<UUID,Double> bossHurtMap = new HashMap<>();

    private double getBossHurtDamage(UUID uuid){
        if(bossHurtMap.get(uuid) == null){
            return 0.0;
        }
        return bossHurtMap.get(uuid);
    }

    private void addPlayerDamage(UUID uuid, double damage){
        if(bossHurtMap.get(uuid) == null){
            bossHurtMap.put(uuid,damage);
            return;
        }
        double newDamage = damage + bossHurtMap.get(uuid);
        bossHurtMap.put(uuid,newDamage);
    }

    public static boolean butt_hurt = false;

    @EventHandler(ignoreCancelled = true, priority = EventPriority.MONITOR)
    public void EntityDamageByEntity(EntityDamageByEntityEvent e) {
        if(!(e.getEntity() instanceof Player)) {
            Entity entity = e.getEntity(); // 获取受伤生物
            String customName = entity.getCustomName(); // 获取生物自定义名
            BossManage bossManage = Main.bossManage; // 获取boss管理
            if (customName != null && bossManage.isCustomNameContains(customName)) {
                BossData bossData = bossManage.getNameToData(customName);
                DamageEvent(e, bossData);
            }
        }
    }

    public void DamageEvent(EntityDamageByEntityEvent e, BossData dataAPI){
        double damage = e.getDamage();
        if(butt_hurt){
            int start_armor_boss = dataAPI.getBossArmor();
            int damage_limit_1 = (int) (start_armor_boss * 0.1); // 200W
            int damage_limit_2 = (int) (start_armor_boss * 0.01); // 20W
            int damage_limit_3 = (int) (start_armor_boss * 0.001); // 2W
            if(damage >= damage_limit_1){
                int rand_damage = DemonAPI.getRandomInt((damage_limit_2*5), damage_limit_2);
                e.setDamage(rand_damage);
            }else if(damage >= damage_limit_2){
                int rand_damage = DemonAPI.getRandomInt(damage_limit_2*3, damage_limit_3);
                e.setDamage(rand_damage);
            }
            return;
        }
        if(damage <= dataAPI.getBossArmor()) {
            Entity entity = e.getEntity();
            UUID uuid = entity.getUniqueId();
            if (bossHurtMap.get(entity.getUniqueId()) != null) {
                addPlayerDamage(uuid,damage);
                double boss_armonr = getBossHurtDamage(uuid);
                if (boss_armonr >= dataAPI.getBossArmor()) {
                    StartBossArmor("累伤触发");
                }
            } else {
                addPlayerDamage(uuid,damage);
            }
        } else {
            StartBossArmor("瞬伤触发");
            e.setCancelled(true);
        }
    }

    public void StartBossArmor(String type){
        butt_hurt = true;
        int s = DemonAPI.getRandomInt(25, 10);
        Bukkit.getConsoleSender().sendMessage("开启保护  开启保护  开启保护  开启保护#"+s+"s || "+type);
        Bukkit.getScheduler().runTaskLater(Main.plugin, (Runnable) new Runnable() {
            @Override
            public void run() {
                butt_hurt = false;
                bossHurtMap.clear();
                Bukkit.getConsoleSender().sendMessage("关闭保护  关闭保护  关闭保护  关闭保护 ");
            }
        }, (long) 20*s);
    }
}
