package com.io.yaohun.worldbosshurt.listener;

import com.io.yaohun.worldbosshurt.util.BossStack;
import me.Demon.DemonHunHuanSX.HunHuanAPI;
import me.Demon.DemonHunHuanSX.Main;
import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.ItemKuAPI;
import net.minecraft.server.v1_12_R1.NBTTagCompound;
import org.bukkit.Bukkit;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.Action;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.inventory.EquipmentSlot;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.List;

public class BossProveEvent implements Listener {

    public static String invTitle = "斗魂偙国 - 十万年凭证兑换";
    /*
    * 交换兑换十万年魂环
    * */
    @EventHandler
    public void onclick(InventoryClickEvent e){
        int rawSlot = e.getRawSlot();
        Player p = (Player) e.getWhoClicked();
        Inventory inv = e.getInventory();
        ItemStack item = e.getCurrentItem();
        if(inv != null && invTitle.equalsIgnoreCase(inv.getTitle())){
            e.setCancelled(true);
            if(!DemonAPI.itemIsNull(item) && !DemonAPI.itemIsLore(item)){
                p.playSound(p.getLocation(),Sound.BLOCK_COMPARATOR_CLICK,1.6F,1.8F);
                NBTTagCompound nbt = BossStack.getNBT(item);
                if(nbt.hasKey("hhkey")){
                    String hhkey = nbt.getString("hhkey");
                    p.closeInventory(); // 关闭界面
                    ItemStack needStack = BossStack.BossSlashProof(hhkey);
                    if(!DemonAPI.isPlayerItemsLore(p,needStack,8)){
                        DemonAPI.sendMessage(p,"兑换失败，缺少该十万年灵兽的猎杀凭证。",Sound.ENTITY_VILLAGER_NO);
                        return;
                    }
                    ItemStack laborStack = ItemKuAPI.getItems("劳动者结晶",1);
                    if(!DemonAPI.isPlayerItemsLore(p,laborStack,2)){
                        DemonAPI.sendMessage(p,"兑换失败，缺少劳动者结晶。",Sound.ENTITY_VILLAGER_NO);
                        return;
                    }
                    DemonAPI.removePlayerItemsLore(p,needStack,8); // 扣除凭证
                    DemonAPI.removePlayerItemsLore(p,laborStack,2); // 扣除劳动者结晶
                    ItemStack hh_item = HunHuanAPI.getHHItems("十万年_"+hhkey+"灵环");
                    p.getInventory().addItem(hh_item);
                    p.sendMessage(Main.prefix+"兑换成功，你获得了 "+hh_item.getItemMeta().getDisplayName());
                    return;
                }
                if(nbt.hasKey("hhkeypro")){
                    String hhkey = nbt.getString("hhkeypro");
                    p.closeInventory(); // 关闭界面
                    ItemStack needStack = BossStack.BossSlashProof(hhkey);
                    if(!DemonAPI.isPlayerItemsLore(p,needStack,12)){
                        DemonAPI.sendMessage(p,"兑换失败，缺少该十万年灵兽的猎杀凭证。",Sound.ENTITY_VILLAGER_NO);
                        return;
                    }
                    // 获取灵环精片
                    ItemStack spermTablets = ItemKuAPI.getItems("灵环精片",1);
                    if(!DemonAPI.isPlayerItemsLore(p,spermTablets,64)){
                        DemonAPI.sendMessage(p,"兑换失败，缺少灵环精片。",Sound.ENTITY_VILLAGER_NO);
                        return;
                    }
                    ItemStack laborStack = ItemKuAPI.getItems("劳动者结晶",1);
                    if(!DemonAPI.isPlayerItemsLore(p,laborStack,10)){
                        DemonAPI.sendMessage(p,"兑换失败，缺少劳动者结晶。",Sound.ENTITY_VILLAGER_NO);
                        return;
                    }
                    DemonAPI.removePlayerItemsLore(p,needStack,12); // 扣除凭证
                    DemonAPI.removePlayerItemsLore(p,laborStack,10); // 扣除劳动者结晶
                    DemonAPI.removePlayerItemsLore(p,spermTablets,64); // 扣除灵环精片
                    ItemStack hh_item = HunHuanAPI.getHHItems("十万年_"+hhkey+"灵环");
                    ItemMeta meta = hh_item.getItemMeta();
                    List<String> lore = meta.getLore();
                    lore.add("§d十万年灵兽自愿献祭标识");
                    meta.setLore(lore);
                    hh_item.setItemMeta(meta);
                    p.getInventory().addItem(hh_item);
                    p.sendMessage(Main.prefix+"兑换成功，你获得了 "+hh_item.getItemMeta().getDisplayName());
                }
            }
        }
    }
    /*
    * 玩家手持凭证打开兑换界面
    * */
    @EventHandler
    public void onUse(PlayerInteractEvent e){
        Player player = e.getPlayer();
        ItemStack item = player.getInventory().getItemInMainHand();
        if(e.getHand() == EquipmentSlot.HAND){
            if(e.getAction() == Action.RIGHT_CLICK_AIR || e.getAction() == Action.RIGHT_CLICK_BLOCK){
                if(BossStack.isItemBossProve(item)){
                    e.setCancelled(true);
                    BossProveEvent.OpenGui(player);
                    player.playSound(player.getLocation(), Sound.BLOCK_COMPARATOR_CLICK,1.6F,1.8F);
                }
            }
        }
    }

    public static void OpenGui(Player p){
        Inventory inv = Bukkit.createInventory(null,27,invTitle);
        inv.setItem(0,Show_Items("巨兽泰坦"));
        inv.setItem(1,Show_Items("青天牛马"));
        inv.setItem(2,Show_Items("奇灵舞魅兔"));
        inv.setItem(3,Show_Items("冰封魔焰虎"));
        inv.setItem(4,Show_Items("噬魂蛛皇"));
        inv.setItem(5,Show_Items("雷暴狮王"));
        inv.setItem(18,Hd_Items("巨兽泰坦"));
        inv.setItem(19,Hd_Items("青天牛马"));
        inv.setItem(20,Hd_Items("奇灵舞魅兔"));
        inv.setItem(21,Hd_Items("冰封魔焰虎"));
        inv.setItem(22,Hd_Items("噬魂蛛皇"));
        inv.setItem(23,Hd_Items("雷暴狮王"));
        p.openInventory(inv);
    }

    public static ItemStack Show_Items(String keyName){
        ItemStack item = HunHuanAPI.getHHItems("十万年_"+keyName+"灵环");
        ItemMeta meta = item.getItemMeta();
        List<String> lore = meta.getLore();
        lore.add(" ");
        lore.add("§7-----[兑换需求材料]-----");
        lore.add("§c§l猎杀凭证 §f("+keyName+") §7x 8");
        lore.add("§2§l劳动者结晶 §7x 2");
        lore.add("§a§l✔§f左键点击兑换");
        meta.setLore(lore);
        item.setItemMeta(meta);
        NBTTagCompound nbt = BossStack.getNBT(item);
        nbt.setString("hhkey",keyName);
        return BossStack.setNBT(item,nbt);
    }

    public static ItemStack Hd_Items(String keyName){
        ItemStack item = HunHuanAPI.getHHItems("十万年_"+keyName+"灵环");
        ItemMeta meta = item.getItemMeta();
        List<String> lore = meta.getLore();
        lore.add("§d十万年灵兽自愿献祭标识");
        lore.add(" ");
        lore.add("§7-----[兑换需求材料]-----");
        lore.add("§c§l猎杀凭证 §f("+keyName+") §7x 12");
        lore.add("§b§l灵环精片 §7x 64");
        lore.add("§2§l劳动者结晶 §7x 10");
        lore.add("§a§l✔§f左键点击兑换");
        lore.add("§b#活动期间限时开放");
        meta.setLore(lore);
        item.setItemMeta(meta);
        NBTTagCompound nbt = BossStack.getNBT(item);
        nbt.setString("hhkeypro",keyName);
        return BossStack.setNBT(item,nbt);
    }
}
