package com.io.yaohun.worldbosshurt.util;

import com.io.yaohun.worldbosshurt.Main;
import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.craftbukkit.v1_12_R1.inventory.CraftItemStack;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import net.minecraft.server.v1_12_R1.NBTTagCompound;

import java.util.*;
import java.util.stream.Collectors;

public class BossStack {


    public static NBTTagCompound getNBT(ItemStack Equipment) {
        net.minecraft.server.v1_12_R1.ItemStack nmsEquipment = CraftItemStack.asNMSCopy(Equipment);
        return nmsEquipment.hasTag() && nmsEquipment.getTag() != null ? nmsEquipment.getTag() : new NBTTagCompound();
    }

    public static ItemStack setNBT(ItemStack item, NBTTagCompound nbtEquipment) {
        net.minecraft.server.v1_12_R1.ItemStack nmsEquipment = CraftItemStack.asNMSCopy(item);
        nmsEquipment.setTag(nbtEquipment);
        return CraftItemStack.asBukkitCopy(nmsEquipment);
    }

    /*
    * 增加玩家每月Boss击杀数
    * */
    public static ItemStack BossSlashProof(String bossName){
        ItemStack item = new ItemStack(Material.PAPER,1);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§c§l猎杀凭证 §f("+bossName+")");
        List<String> lore = new ArrayList<>();
        lore.add("§c§l★§7通过猎杀§c十万年级§7以上");
        lore.add("§7灵兽§a掉落§7的凭证,§a集齐多张");
        lore.add("§7可兑换§c十万年级§7以上灵环!");
        lore.add("§b§l✪§7务必要妥善保管此凭证!");
        meta.setLore(lore);
        item.setItemMeta(meta);
        NBTTagCompound nbt = getNBT(item);
        nbt.setString("stex","cailiao_68");
        return setNBT(item,nbt);
    }

    public static boolean isItemBossProve(ItemStack item){
        if(DemonAPI.itemIsNull(item) || DemonAPI.itemIsLore(item)){
            return false;
        }
        ItemMeta meta = item.getItemMeta();
        if(meta.getDisplayName().contains("§c§l猎杀凭证")){
            if(meta.getLore().contains("§7灵兽§a掉落§7的凭证,§a集齐多张")){
                return true;
            }
        }
        return false;
    }
}
