package com.io.yaohun.worldbosshurt.util;

import com.io.yaohun.worldbosshurt.Main;
import me.Demon.DemonBanK.BankAPI;
import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.Bukkit;
import org.bukkit.configuration.file.FileConfiguration;

import java.util.Comparator;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.stream.Collectors;

public class BossUtil {

    public static String finallyKills = "§6[§4公告§6] §a玩家 §c%p% §a夺取了 §r%mobs% §6§l最终一击!";

    public static String getFinallyKills() {
        return finallyKills;
    }

    /*
    * 增加玩家每月Boss击杀数
    * */
    public static void addMonthlyKillBoss(String name){
        FileConfiguration yml = Main.plugin.getConfig();
        int killAmount = yml.getInt("MonthlyKillsTop."+name);
        yml.set("MonthlyKillsTop."+name,(killAmount+1));
        Main.plugin.saveConfig();
    }

    /*
    * 获取每月数据刷新时间
    * */
    public static String getTimeMonthly(){
        FileConfiguration yml = Main.plugin.getConfig();
        if(yml.getString("TimeMonth") != null){
            return yml.getString("TimeMonth");
        }
        return "2022/04";
    }

    /*
    * 判断本月数据是否刷新
    * */
    public static boolean isTimeMonthly(){
        if(!getTimeMonthly().equalsIgnoreCase(DemonAPI.getTime("yyyy/MM"))){
            return true;
        }
        return false;
    }

    /*
    * 结算上月累积击杀十万年次数排行
    * */
    public static void settlementRankingRewards() {
        FileConfiguration yml = Main.plugin.getConfig();
        yml.set("TimeMonth", DemonAPI.getTime("yyyy/MM")); // 设置本月时间
        HashMap<String, Integer> hashMap = new HashMap<>(); // 统计击杀boss次数
        if (yml.getConfigurationSection("MonthlyKillsTop") != null) {
            for (String name : yml.getConfigurationSection("MonthlyKillsTop").getKeys(false)){
                int killAmount = yml.getInt("MonthlyKillsTop."+name); // 获取击杀boss次数
                hashMap.put(name,killAmount); // put次数
            }
            yml.set("MonthlyKillsTop",null); // 清理本地数据
        }
        if(hashMap.size() >= 1){
            // 为HashMap中数值进行降序排序
            LinkedHashMap<String, Integer> sortedMap = hashMap.entrySet()
                    .stream()
                    .sorted(Map.Entry.comparingByValue(Comparator.reverseOrder()))
                    .collect(Collectors.toMap(
                            Map.Entry::getKey,
                            Map.Entry::getValue,
                            (e1, e2) -> e1,
                            LinkedHashMap::new
                    ));
            // 遍历sortedMap中的数据
            int rank = 1;
            for (String name : sortedMap.keySet()){
                int kill_amount = sortedMap.get(name);
                if(rank == 1) {
                    Bukkit.broadcastMessage("§6[§4灵兽猎杀排行§6] §a玩家 §e" + name + " §a上月总计猎杀: §6" + kill_amount + "只 §a获得奖励: §d§l点券§fx1000");
                    BankAPI.addPoints(name,1000);
                }else if(rank == 2){
                    Bukkit.broadcastMessage("§6[§4灵兽猎杀排行§6] §a玩家 §e" + name + " §a上月总计猎杀: §6" + kill_amount + "只 §a获得奖励: §d§l点券§fx750");
                    BankAPI.addPoints(name,750);
                }else if(rank == 3){
                    Bukkit.broadcastMessage("§6[§4灵兽猎杀排行§6] §a玩家 §e" + name + " §a上月总计猎杀: §6" + kill_amount + "只 §a获得奖励: §d§l点券§fx500");
                    BankAPI.addPoints(name,500);
                }else if(rank == 4){
                    Bukkit.broadcastMessage("§6[§4灵兽猎杀排行§6] §a玩家 §e" + name + " §a上月总计猎杀: §6" + kill_amount + "只 §a获得奖励: §d§l点券§fx250");
                    BankAPI.addPoints(name,250);
                }else if(rank == 5){
                    Bukkit.broadcastMessage("§6[§4灵兽猎杀排行§6] §a玩家 §e" + name + " §a上月总计猎杀: §6" + kill_amount + "只 §a获得奖励: §d§l点券§fx100");
                    BankAPI.addPoints(name,100);
                    break;
                }
                rank++;
            }
        }
        Main.plugin.saveConfig(); // 保存本地数据
        Bukkit.getConsoleSender().sendMessage("[日志 - 世界BOSS] 成功结算上月玩家的Boss总击杀榜.");
    }
}
